
import {EventEmitter} from 'events'
var Fs= core.System.IO.Fs
var R= core.org.voxsoftware.Rtmp.Downloader


class Server extends EventEmitter{
	
	constructor(){
		var server= this.server= new core.VW.Http.Server()
		this.server.port=0
		this.server.timeout= 60000
		this.id=0
		
	}

	async init(){
		var server= this.server
		this.initServer()

		this.emit("init")
		await server.listen()

		this.emit("listen")
		vw.log("Server disponible: 127.0.0.1:", server.port)
		while(true){
			var reqArgs= await server.acceptAsync()
			this._continue(reqArgs);
		}
	}


	get port(){
		return this.server.port
	}

	async _continue(req){
		var time= new Date()
		var id= ++this.id
		req.id= id
		
		try{
			req.request.url=req.request.url.trim()
			//this.console.request(req.request.method, req.request.url, " ID: ", id)
			await req.catch(req.continue)
			//this.console.info("Solicitud completa: ", id, " Tiempo: ", new Date()-time, "ms")
		}
		catch(e){
			try{
				req.response.statusCode=500
				try{req.response.write(JSON.stringify({error:e.stack},4,'\t'));}catch(ex){}
				req.response.end()
			}
			catch(ex){}
		}
	}



	writeResponse(response, buf){
		var task= new core.VW.Task()
		response.write(buf, null, function(err, data){
			if(err)
				task.exception=err
			task.result= data
			task.finish()
		})

		return task
	}


	initServer(){
		var router= this.server.router, self= this
		router.get("/download", async (args)=>{

			var params= args.request.query
			var uid= params.uid, info, url
			url= params.url
			if(!uid && !url)
				throw new core.System.Exception("El uid es incorrecto")


			var r

			if(!uid){
				r= new R.Channel()
				r= await r.startDownload(url)
				uid= r.uid
			}


			var download= R.Channel.downloads[uid]
			if(!download)
				throw new core.System.Exception("El uid es incorrecto")


			var readed= 0, buf= new Buffer(8120)
			buf.fill(0)
			var Stream= new core.System.IO.FileStream(download.file, core.System.IO.FileMode.Open, core.System.IO.FileAccess.Read)
			//var Stream2= new core.System.IO.FileStream("/Users/james/cc.mp4", core.System.IO.FileMode.Truncate, core.System.IO.FileAccess.Write)
			Stream.position=0

			var name, url= download.url, ext
			url= url.split("/")
			name= url[url.length-1]
			ext= name.split(".")
			ext= ext[ext.length-1]
			name= "RTMPDownload." + ext


			args.response.writeHead(200, {
				"Content-disposition": "Attachment;filename=" + name, 
				"Content-type": "video/" + ext
			})

			var o, reading



			var Read=  async function(){
				reading= true
				var l= Stream.length, leido
				while(readed<l){
					Stream.position= readed
					leido= Stream.read(buf, 0, Math.min(l-readed, 8120))
					readed += leido
					if(!o){
						o=true
					}
					await self.writeResponse(args.response, buf.slice(0, leido))
				}
				reading= false
			}
			download.emitprogress= function(){
				if(!reading)
					Read()
			}


			download.emitend= async function(){
				await Read()
				args.response.end()
				Read=null
				try{
					Fs.sync.unlink(download.file)
				}
				catch(e){
				}
			}



		})
	}

}
export default Server